
c    Copyright 2003 Lars Ottemoller and Jens Havskov
c
c    This file is part of SEISNET.
c
c    SEISNET is free software; you can redistribute it and/or modify
c    it under the terms of the GNU General Public License as published by
c    the Free Software Foundation; either version 2 of the License, or
c    (at your option) any later version.
c
c    Foobar is distributed in the hope that it will be useful,
c    but WITHOUT ANY WARRANTY; without even the implied warranty of
c    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c    GNU General Public License for more details.
c
c    You should have received a copy of the GNU General Public License
c    along with Foobar; if not, write to the Free Software
c    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USa

C$DEBUG
c
c   read file idx_log of ring buffers on field station
c   make a log file for each day or part of day in corresponding
c   station directory. Last day  not made. If file already
c   there, do not make
c
c   J havskov, dec 97
c
c   updates
c
c  sep 30 1998 by jh: read block time from theoretical block time since
c                     real block time might be wrong if difitzer is
c                     sending too little data
c  oct 01 1998    lo: also write to daily logfile and read more input
c  oct 26         jh. Bug with calculating buffer lenght
c  oct 27         lo  use database from input not from idx file
c  oct 27         jh  use cpu time since gps time can be very bad
c  oct 28         JH  also use cpu month and year
c  cccccccccccccccccccccccccccccccccccccccccccccc
c  jaN 99 lo     : -----------version 7.0 check----------------------
c                   year 2000, 5 char base name, long file names
c  jan 3  jh     : check for reading errors when time is xx
c -------------------------------------------------------------------
c ------------- NOW PART OF SEISNET --- June 10, 1999 ---------------

      implicit none

      character*320 block         ! one block in idx file
      integer iblock              ! dimension of block varibles
      parameter(iblock=3000)
      integer day1,month1,year1   ! date for which log should be made
      integer old_day             ! previous day
      integer year(iblock),month(iblock),
     *day(iblock),hour(iblock),min(iblock),sec(iblock)   ! ring buffer time
      integer nblock              ! number of blocks in file with data
      integer ifirst              ! first block number for day
      integer nlog                ! number for log lines for a given day
      character*5 base            ! data base to put log into
      character*5 log_base        ! data base to put log into
      character*5 station         ! station name
      character*80 data(1000)     ! output strings to data base
      character*80 sfile          ! sfile name
      character*80 log_sfile      ! log sfile name
      character*80 idline         ! id line
      character*80 log_file       ! log file name
      CHARACTER*12 p_time         ! system time
      character*14 proc_time      ! system time
      integer length              ! length of sfile name
      integer block_time          ! time of one block in minutes
      integer nout                ! number of output records
      real gps_out                ! times gps synchronized
      real up_gps                 ! uptime of gps
      real up_time                ! up time in % of system
      logical debug
      character*3 mon(12)         ! month text
      integer kfirst(200)         ! addrsses of day starts in log file
      logical new                 ! if true, ring buffer file is new, not full
      double precision time,first_time ! times
      integer i,k,l,j
      data mon/'Jan','Feb','Mar','Apr','May','Jun','Jul','Aug',
     *           'Sep','Oct','Nov','Dec'/
      
      debug=.false. 
      write(6,*)'Log file name' 
      read(5,'(a)') log_file
      write(6,*)'Log databasee' 
      read(5,'(a)') log_base
      write(6,*)'Station name' 
      read(5,'(a)') station 
      write(6,*)'Station database'
      read(5,'(a)') base     
c      base='LOG'
      new=.false.

      do i=1,5
        if (base(i:i).eq.' ') base(i:i)='_'
        if (log_base(i:i).eq.' ') log_base(i:i)='_'
      enddo
c
c   open log file
c
      open
     *(1,file=log_file,status='old',access='direct',recl=320,err=99)
c
c   find block time
c
      j=1
      do i=1,40
         read(1,rec=i) block
         if(block(170:172).eq.'RST') j=1  ! cannot use restart block as 2.
         if(block(90:92).eq.'REC')   j=0  ! cannot use active block as 1.
         read(block(97:105),'(i3,1x,i2,1x,i2)',err=201) 
     *   day(j),hour(j),min(j)
         goto 202
 201     continue
         j=0
 202     continue
c         write(6,*) day(j),hour(j),min(j)
         j=j+1
         if(j.eq.3) then                  ! at least 2 times following were ok
            block_time=(day(2)-day(1))*24*60+
     *      (hour(2)-hour(1))*60+min(2)-min(1)
            goto 666
         endif
      enddo
 666  continue
c
c   read whole file
c
      do i=1,10000
c        read(1,rec=i,end=200) block
         read(1,rec=i,err=200) block
cpc        read(1,rec=i,err=200) block
c        if(i.eq.1.and..not.debug) base=block(40:42)     ! lo
c
c   read times of ring buffer file
c
c       read(block(20:37),'(i4,1x,i2,1x,i2,1x,2i2,1x,i2)')! gps time 
c    *  year(i),month(i),
c    *  day(i),hour(i),min(i),sec(i)
c       read(block(20:37),'(i4,1x,i2)') 
c    *  year(i),month(i)
        read(block(76:79),'(i4)',err=777) year(i)   ! cpu year 
        do k=1,12
          if(mon(k).eq.block(60:62)) month(i)=k   ! cpu month
        enddo
        read(block(64:74),'(i2,1x,i2,1x,i2,1x,i2)',err=777)   ! cpu time
     *  day(i),hour(i),min(i),sec(i)
        goto 778
 777    continue
        year(i)=0
        month(i)=0
        day(i)=0
        min(i)=0
        sec(i)=0
 778    continue
c       write(6,*) year(i),month(i),day(i),hour(i),min(i),sec(i)
c
c   check if not yet written in ring buffer file
c
        if(year(i).eq.0.and.month(i).eq.0) then
           nblock=i-1
           new=.true.
           goto 200
        endif

        nblock=i
      enddo
c
c  all records read
c
 200  continue
      write(6,*)' Number of blocks',nblock
      write(6,*)' Block time',block_time
c
c   find earliest day changes
c
      day1=day(1)
      k=0
      do i=1,nblock
        if(day(i).ne.day1) then
          k=k+1
          kfirst(k)=i      ! save day change address
          day1=day(i)      ! reset day number and look for next
        else
c          day1=day(i)
        endif
      enddo
c
c   find earliest of day change unless this is a new ring buffer in which
c   case the earliest data is the first record, remember record number in
c   file starts with 0, here counted from 1
c
      if(new) then
         ifirst=1
      else
         first_time=10e20
         do l=1,k
           call timsec(year(kfirst(l)),month(kfirst(l)),day(kfirst(l)),
     *     hour(kfirst(l)),
     *     min(kfirst(l)),float(sec(kfirst(l))),time)
           if(time.lt.first_time) then
              first_time=time
              ifirst=kfirst(l)
           endif
         enddo
      endif
c
c  first on new day found
c
           
 500  continue

      write(6,*)'ifirst', ifirst
c
c----------------------------------------
c   enter reading loop for days
c----------------------------------------
c   
c
      i=ifirst
c
 600  continue
c
c   make s-file name
c
      year1=year(i)
c      if(year(i).gt.100) year1=year(i)-1900
c      year1=year(i)-1900
      day1=day(i)
      month1=month(i)
      call sfilname
     *(year1,month1,day1,0,0,0,base,'L',sfile,length)

c
c changed 29 feb 2000
c
      call sfilname
     *(year1,month1,day1,0,0,1,log_base,'L',log_sfile,length)

c
c   put info into output array, first make header
c
c      if(year1.lt.200) year1=year1+1900
      nout=1             ! first line
      data(1)=' '
      write(data(nout)(1:24),'(1x,i4,1x,2i2,1x,a)')
     *year1,month(i),day(i),'0000 00.0 LL'
      data(1)(46:48)='LOG'          ! agency is LOG
      data(1)(80:80)='1'
c
c   2 blank lines for comments
c
      data(2)=' '
      data(2)(80:80)='3'
      data(3)=' '
      data(3)(80:80)='3'
c
c   find down time
c
      nout=4
      data(nout)=' '
      data(nout)(1:21)=' SEISLOG up time in %'
      data(nout)(80:80)='3'
c
c   find GPS performance
c
      nout=nout+1
      data(nout)=' '
      data(nout)(1:17)=' GPS UP time in %'
      data(nout)(80:80)='3'
c
c   one blank line
c
      nout=nout+1
      data(nout)=' '
      data(nout)(80:80)='3'
c
c   put in detailed info
c
      gps_out=0
      nlog=0
c
c   read info from log file
c
      old_day=day1
      do while(day(i).eq.old_day)
        nout=nout+1
        nlog=nlog+1                     ! count log lines for day
        data(nout)=' '
        data(nout)(80:80)='3'
        read(1,rec=i) block             ! read one record
        data(nout)(2:35)=block(14:47)   ! ring buffer file name
        data(nout)(38:45)='UP time '
        data(nout)(47:55)=block(97:105) ! total up time
c
        data(nout)(58:60)=block(116:118) ! gps settting
c
c  count gps down time
c
        if(data(nout)(58:60).ne.'SET') then
          gps_out=gps_out+1
        endif
        data(nout)(63:65)=block(170:172) ! restart flag
        old_day=day(i)
        i=i+1
        if(i.eq.ifirst) goto 100        ! do not write data for last day
        if(i.gt.nblock) i=1             ! wrap around
        if(ifirst.eq.1.and.i.eq.1) goto 100   ! could be that the first is #1
      enddo
c
c   id line
c
      idline(1:40)= ' ACTION:                   OP:     STATU'                                                  
      idline(41:80)='S:               ID:                   I'
      WRITE(IDLINE(61:75),'(i4,5I2)')
     *YEAR1,MONTH1,DAY1,0,0,0
      DO k=61,74
         IF(IDLINE(k:k).EQ.' ') IDLINE(k:k)='0'
      ENDDO
      WRITE(IDLINE(31:34),'(A)')'ONL'
C
C   GET SYSTEM TIME
C
      CALL SYSTIME(p_time,PROC_TIME)

      WRITE(IDLINE(13:26),'(A)')PROC_TIME
      WRITE(IDLINE(9:11),'(A)')'NEW' 

      nout=nout+1
      data(nout)=idline
      nout=nout+1
      data(nout)=
     *' NET ASO YES                               '
     *//'                                    3'
      nout=nout+1
      data(nout)=' '
c
c   calculate and store statistics
c
      up_gps=100.0-gps_out*100.0/nlog
      write(data(5)(30:40),'(F7.2)') up_gps
      up_time=nlog*block_time/(24.0*0.60)
      write(data(4)(30:40),'(f7.2)') up_time
c
c   open and write output file, but only if not there
c
      write(6,*) ' Make file for ',base,year1,month1,day1
      open(3,file=sfile,status='new',err=599)    ! if old file, go to next day
c     open(3,file='s.out',status='unknown')
      write(3,'(a80)') (data(k),k=1,nout)  
      close(3)

c
c  update daily log_file
c
      open(3,file=log_sfile,status='old',err=599)

      nout=0
 585  continue

      nout = nout +1
      read(3,'(a)',end=590) data(nout)

c23456789012345678901234567890123456789012345678901234567890
cASK    1   0   1   0   0   0.0   0.0   0.0  79                            *** 3

      if (data(nout)(2:5).eq.station) then

        write(data(nout)(33:37),'(f5.1)') up_time
        write(data(nout)(39:43),'(f5.1)') up_gps
      endif

      goto 585 

 590  continue

      rewind(3)
      nout=nout-1

      write(3,'(a80)') (data(k),k=1,nout)

      close(3)
         


      goto 600
c
 599  continue
      write(6,*)' File already made or directory not there'
      goto 600                        ! data from next day

c
c  if here, error
c
 99   continue
      write(6,*)' Error in log file'
c
c  end of program
c
 100  continue
      write(6,*)' Statistics of uptime for seislog and gps '
      write(6,'(2f8.1)') up_time,up_gps

      write(*,*) ' FINISHED'
      stop
      end




