
c    Copyright 2003 Lars Ottemoller and Jens Havskov
c
c    This file is part of SEISNET.
c
c    SEISNET is free software; you can redistribute it and/or modify
c    it under the terms of the GNU General Public License as published by
c    the Free Software Foundation; either version 2 of the License, or
c    (at your option) any later version.
c
c    Foobar is distributed in the hope that it will be useful,
c    but WITHOUT ANY WARRANTY; without even the implied warranty of
c    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c    GNU General Public License for more details.
c
c    You should have received a copy of the GNU General Public License
c    along with Foobar; if not, write to the Free Software
c    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USa

c
c changes:
c
c   29 Nov 2002 lo: change in wave_request to not write out wav and ext file if not needed
c   25 Feb 2003 lo: changed wave_request to write sfile name for autodrm

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
      subroutine xxxGetDateBefore(n,datebef)
 
c Luis A. Arriola: jul 1997
c
c Calculate date for n days before curr date
c
 
        implicit none
 
        integer year, month, day, dofy, hour, min,secs
        real sec
        double precision msec       !   time in seconds
    
        character*14 curr ,datebef
        integer c                      ! counter
        integer n
 
c
c   get GMT system time
c
        call gmttim(curr)

        write(*,*) curr
 
c
c  read time from current time
c
        read(curr(1:4),'(i4)') year
        read(curr(5:6),'(i2)') month
        read(curr(7:8),'(i2)') day
        read(curr(9:10),'(i2)') hour
        read(curr(11:12),'(i2)') min
        read(curr(13:14),'(i2)') secs
 
        sec = secs    ! sec real in timesec
 
c
c   convert time to seconds
c
        call timsec(year,month,day,hour,min,sec,msec)
 
c
c  subtract n days in secs
c
        msec= msec - real(n * 86400.0)
 
c
c  convert seconds back to time
c
        call sectim(msec,year,dofy,month,day,hour,min,sec)
 
        secs = abs(sec)
 
c
c   output
c
        write(datebef,'(i4,i2,i2,i2,i2,i2)') year,month,day,hour,min
     &  ,secs
 
        do c=1,14
          if (datebef(c:c).eq.' ') datebef(c:c)='0'
        enddo
 
 
        return
      end
 
c     end of subroutime GetDateBefore
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
 
      subroutine wave_request(sfile,wav_request_dir)
 
c
c subroutine to read data base and write list of waveform files, this
c routine works on the central database and seperates requests from 
c different stations to their respective files
c
c Lars Ottemoeller, 14.08.97
c
 
       implicit none
       include 'seidim.inc'

       character*(*) sfile
       character*(*) wav_request_dir

C
C    Seisan library inserts and routines...
C    ======================================
C
       include 'libsei.inc'                ! Open file definitions
C
       external sei open,                  ! Open file routine.
     &          sei close,                 ! Close file routine.
     &          sei code                   ! Error encoder.

       integer sei clen
C
C    ============= end of list ==========
C

c-- event data
       character*80     data(max_data)
c-- exp indicator
       character*1      exp
c-- event type
       character*1      type
c-- number of recors for event
       integer          nrecord
c-- number of header lines
       integer          nhead
c-- number of stations
       integer    nstat
c - number of phases
       integer nphase
c-- start and end time of select
       character*14    start_time,end_time
c-- data base name if not agency (blank)
       character*40     base_name,central_base
c-- select key
       character*10     key
c-- see subroutine find...
       integer          status,new_month,fstart,event_no
c-- true if file exists (CLK)
       logical          exist
c-- id line number
       integer id
c logical for olf file
       logical          b_old
c returned code
       integer          code
c read unit #1
       integer          read01
c write unit #1
       integer          write01,write02
       integer c,x                            ! counter
c  name of QNX waveform file
       character*42 qnx_wave
c  iris waveform start time
       character*26 iris_wave
c  output file name, and output filename for extract file
       character*200 outfile,ext_outfile

c station name
       character*5 station
c station name (IRIS only)
       character*5 iris_station
c number of components in list
c       integer n_comp
c array of output components
c       character*5 comp_out(7)
c length of event in seconds or samples
       character*5 event_length
c ftp file name
       character*42 ftp_wave
       character*4 wav_file
       character*80 sfile_name
       character*6 wtype
c if qnx extract file written
       logical qnx_ext
c naqs wav line
       character*80 naqs_wave
       integer year,month,day,hour,min,sec,doy
       real pre,rsec,duration
       double precision msec

      inquire(file=sfile,exist=exist)
c
c get database
c
      base_name=sfile(seiclen(sfile)-32:seiclen(sfile)-28)
c      write(*,*) ' xxx '//base_name

      if (exist) then
            call file_ready(sfile)
            call sei open(old$+warn$,            ! Open an old file.
     &                    ' ',                   ! Prompt file name (n/a).
     &                    sfile,                ! File name
     &                    read01,                ! Read unit #1
     &                    b_old,                 ! Already exists? (n/a).
     &                    code)                  ! Returned condition.
 
        call indata(read01,nstat,nphase,nhead,nrecord,type,exp,data,id)
 
           call sei close (close$,read01,code)
 
cNET WAV EVE UPA  QNX 9708_14_0515_38T.UPA_27_1        STA140806 REQUEST       3
c97  8 Reading events from base UPI  25
c/net/seismo/online/REA/UPI/97/08/11-0116-15D.S9708
cNET WAV EVE KBS  IRI BHZ   1997 248=09/05 21:22:20.8  STA120958 REQUEST       3
cNET WAV EVE CUIG IRI BHZ   2000/02/06 11:52:02  6000
cNET WAV EVE NRA0 AUT 19990126115558                             REQUEST       3
c
c   check for waveform requests
c
 
           do c=1,nhead
             qnx_ext = .false.
             if ((data(c)(2:8).eq.'ONL WAV'.or.
     &            data(c)(2:8).eq.'NET WAV').and.
     &           (data(c)(66:72).eq.'REQUEST'.or.
     &            data(c)(76:78).eq.'REQ'))
     &             then    ! changed April 2001, lo

c
c  read station name
c
               read(data(c)(14:18),'(a5)') station
               write(*,*) station
c
c   set output file name
c
               if (((data(c)(19:21).eq.'QNX'.or.data(c)(19:21).eq.'VME'
     &           .or.data(c)(19:21).eq.'SEI')
     &           .and.data(c)(10:12).ne.'EXT').or.
     &           (data(c)(19:21).ne.'QNX'.and.data(c)(19:21).ne.'VME')
     &           .and.data(c)(19:21).ne.'SEI')
     &         then
                 outfile=' '
                 outfile=wav_request_dir(1:seiclen(wav_request_dir))// 
     &               '/'// station(1:seiclen(station)) // '.wav'
                 call freefile(outfile)

                 write(*,*) 'writing to...',outfile(1:seiclen(outfile))

                 call file_ready(outfile)
                 call sei open(new$,       ! Open an old file.
     &                    ' ',                   ! Prompt file name (n/a).
     &                    outfile,               ! File name
     &                    write01,               ! Read unit #1
     &                    b_old,                 ! Already exists? (n/a).
     &                    code)                  ! Returned condition.

               endif

c
c   set output file name for QNX or VME extract file (e.g. *.WAV1EXT )
c
               if ((data(c)(19:21).eq.'QNX'.or.data(c)(19:21).eq.'VME'
     &           .or.data(c)(19:21).eq.'SEI')
     &           .and.data(c)(10:12).eq.'EXT') then
                 ext_outfile=' '
                 ext_outfile=
     &                wav_request_dir(1:seiclen(wav_request_dir))// 
     &                '/'//station(1:seiclen(station)) // '.ext'
                 call freefile(ext_outfile)
c
c    open new output file if not exist
c
                   call file_ready(ext_outfile)
                   call sei open(new$,       ! Open an old file.
     &                    ' ',                   ! Prompt file name (n/a).
     &                    ext_outfile,               ! File name
     &                    write02,               ! Read unit #1
     &                    b_old,                 ! Already exists? (n/a).
     &                    code)                  ! Returned condition.
               endif    ! QNX or VME

               if (data(c)(19:21).eq.'QNX') then
                 if (data(c)(10:12).eq.'EVE') then

                   qnx_wave = data(c)(23:64)
 
                   write(*,'(a42,1x,a80)') qnx_wave(1:42),sfile(1:80)
                   write(write01,'(a42,1x,a80)') qnx_wave(1:42),
     &                   sfile(1:80)
      
                  elseif (data(c)(10:12).eq.'EXT') then
                    qnx_ext = .true.
                    qnx_wave = data(c)(23:50)
                    write(*,'(a25,1x,a80)') qnx_wave(1:25),sfile(1:80)
                     write(write02,'(a25,1x,a80)') qnx_wave(1:25),
     &                   sfile(1:80)
                 endif

               elseif (data(c)(19:21).eq.'VME') then
                 if (data(c)(10:12).eq.'EVE') then
                   qnx_wave = ' '
                   if (data(c)(23:30).ne.'        ') then
                     qnx_wave = data(c)(23:30)
                     write(*,'(a5,1x,a60)') qnx_wave(1:28),
     &                     sfile(1:80)
                     write(write01,'(a4,1x,a80)') qnx_wave(1:4),
     &                     sfile(1:80)
                   endif

                 elseif (data(c)(10:12).eq.'EXT') then

                    qnx_ext = .true.
                    qnx_wave = data(c)(23:50)

                    write(*,'(a25,1x,a80)') qnx_wave(1:25),sfile(1:80)
                     write(write02,'(a25,1x,a80)') qnx_wave(1:25),
     &                   sfile(1:80)
                 endif

               elseif (data(c)(19:21).eq.'FTP') then

                 if (data(c)(66:72).eq.'REQUEST') then
                   ftp_wave = data(c)(23:64)
                 else
                   ftp_wave = data(c)(23:74)
                 endif

                 write(*,'(a,1x,a80)') ftp_wave(1:seiclen(ftp_wave))
     &             ,sfile(1:80)
                 write(write01,'(a,1x,a80)') 
     &                  ftp_wave(1:seiclen(ftp_wave)),
     &                   sfile(1:80)


               elseif (data(c)(19:21).eq.'AUT') then

                 write(*,*) data(c)(23:36) 
                 write(write01,'(3a)') 
     &                data(c)(23:36) // ' ' // base_name(1:5) // ' '
     &                // sfile(1:seiclen(sfile))   ! added sfile, lot 25022003

               elseif (data(c)(19:21).eq.'IRI') then
 
cNET WAV EVE CUIG IRI BHZ   2000/02/06 11:52:02  6000
c  component
                 iris_wave(1:6)=data(c)(23:28)
                 iris_wave(7:7)=' '
 
c date/time
                 iris_wave(8:26)=data(c)(29:47)

c station
c                 iris_station(1:5) = data(c)(14:18)
              
c  event length
                 event_length = data(c)(49:53)
 
                 write(*,'(a26,3x,a5,1x,a80)') iris_wave,
     &                  event_length(1:5),sfile(1:80)
                 write(write01,'(a26,3x,a5,1x,a80)') iris_wave,
     &                  event_length(1:5),sfile(1:80)

               elseif (data(c)(19:21).eq.'SEI') then
                  if (data(c)(10:12).eq.'EVE') then
                     write(*,'(a,1x,a)') data(c)(23:74),
     &                 sfile(1:seiclen(sfile))
                     write(write01,'(a,1x,a)') data(c)(23:74),
     &                 sfile(1:seiclen(sfile))
                  elseif (data(c)(10:12).eq.'EXT') then
                    qnx_ext = .true.
                     write(*,'(a,1x,a)') data(c)(23:74),
     &                 sfile(1:seiclen(sfile))
                     write(write02,'(a,1x,a)') data(c)(23:74),
     &                 sfile(1:seiclen(sfile))
                  endif
               elseif (data(c)(19:21).eq.'SDA') then
cNET WAV EXT LNSD SDA 12/11/2002 08:59:32    30
                 write(*,'(a,1x,a)') data(c)(23:47),sfile(1:80)
                 write(write01,'(a,1x,a)') data(c)(23:47),sfile(1:80)

               elseif (data(c)(19:21).eq.'NAQ') then
c2345678901234567890123456789012345678901234567890123456789012345678901234567890
cNET WAV EXT NAQS1NAQ 20010601000000 *.*                 12345     12345   REQ 3
c
c
c subtract preevent time to set start time
c
                 read(data(c)(23:36),'(i4,5i2)')
     &              year,month,day,hour,min,sec
                 read(data(c)(58:67),'(f10.0)') pre
                 rsec=float(sec)
                 call timsec(year,month,day,hour,min,rsec,msec)
                 msec = msec - pre 
c
c set duration
c
                 read(data(c)(68:72),'(f5.0)') duration
                 duration=duration+pre
                 write(data(c)(68:72),'(i5)') int(duration)

                 call sectim(msec,year,doy,month,day,hour,min,rsec)
                 sec=int(rsec)
                 write(data(c)(23:36),'(i4.4,5i2.2)')
     &              year,month,day,hour,min,sec

                 naqs_wave=' '
                 naqs_wave=data(c)(23:26)//'-'//
     &                     data(c)(27:28)//'-'//
     &                     data(c)(29:30)//'-'//
     &                     data(c)(31:32)//'-'//
     &                     data(c)(33:34)//'-'//
c     &                     data(c)(35:36)// ' '// '"' //
     &                     data(c)(35:36)// ' '//
     &                     data(c)(38:38+seiclen(data(c)(38:56)))// 
c     &                     '" '//
     &                     ' '//
     &                     data(c)(68:74)

                 write(*,'(a,1x,a80)') naqs_wave,
     &                  sfile(1:80)
                 write(write01,'(a,1x,a)') 
     &                  naqs_wave(1:seiclen(naqs_wave)),
     &                  sfile(1:seiclen(sfile))
               endif
            
               
               if (data(c)(19:21).eq.'QNX'.or.
     &             data(c)(19:21).eq.'VME'.or.
     &             data(c)(19:21).eq.'SEI') then
                 if (qnx_ext) then
                   call sei close (close$,write02,code)
                 else
                   call sei close (close$,write01,code)
                 endif
               else
                   call sei close (close$,write01,code)
               endif
 
             endif
           enddo
         else
           write(6,'(1x,a80,a)') sfile(1:80),' doesn''t exist.'
         endif

      return
      end
 
c -----   end of subroutine get_wave  ---------
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
 

 
cccccccccccccccccccccccccccccccccccccccccccccccccc
c

      subroutine xxxwhich_database(station,base_name,
     &            station_name,database_name)


c number of databases
       integer max_database
       PARAMETER (max_database=99)
c database names
       character*5 database_name(max_database)
c station names
       character*5 station_name(max_database)
c station name
       character*5 station
c data base name if not agency (blank)
       character*5     base_name
c counter
       integer c

       do c=1,max_database

         if (station_name(c).eq.station) then

           base_name = database_name(c)
           return

         endif

       enddo


       return
       end





ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c

      subroutine xxxget_comp(station,comp_in,n_comp,
     *                       comp_out)

c  subroutine to get list of channels to be transferred for trigger comp.
c  read parameter file, find component line for this station and trigger
c  component and return a list and number of comp.


       implicit none
       include 'seidim.inc'
 
 
C
C    Seisan library inserts and routines...
C    ======================================
C
       include 'libsei.inc'                ! Open file definitions
C
       external sei open,                  ! Open file routine.
     &          sei close,                 ! Close file routine.
     &          sei code                   ! Error encoder.
C
C    ============= end of list ==========

c  station name
      character*4 station,station_name
c  input component
      character*5 comp_in,channel
c number of components in list
       integer n_comp
c array of output components
       character*5 comp_out(7)

c read unit  #1
       integer          read01
c logical for existing file or not
       logical          b_old
c returned code
       integer          code
c station index
       integer x
c parameter line
       character*80 par_line
c channel line
       character*42 channel_line
c name of SEISNET parameter file
       character*80 parameter_file
c counter
       integer ind,i


c
c read SEISNET paramter file
c
      call getenv('SEISNET_PAR',parameter_file)
c      write(*,*) 'SEISNET parameter file: ',parameter_file
 
c
c  init
c
      n_comp=0
      do x=1,42
        channel_line(x:x)=' '
      enddo
      do x=1,7
        comp_out(x)= ' '
      enddo
 
            call file_ready(parameter_file)
            call sei open(old$+warn$,            ! Open a unknown status file.
     &                    ' ',                   ! Prompt file name (n/a).
     &                    parameter_file,        ! File name
     &                    read01 ,               ! Write unit #1
     &                    b_old,                 ! Already exists? (n/a).
     &                    code)                  ! Returned condition.
 
      x=-1
 
 10   CONTINUE
 
      read(read01,'(a)',END=20) par_line

c
c   find station names
c
      if (par_line(5:12).eq.'STATION(') then
 
         ind=index(par_line,')')
 
         read(par_line(31:34),'(a4)') station_name
 

         if (station.eq.station_name) then
           read(par_line(13:ind-1),'(i3)') x
         endif
 
c
c  find components for station name
c
      elseif (par_line(5:14).eq.'COMPONENTS') then
 
        if (x.gt.0) then
          ind=index(par_line,')')
 
          read(par_line(16:ind-1),'(i3)') i
 
          if (i.eq.x) then
 
            read(par_line(32:36),'(a5)') channel
         
            if (channel.eq.comp_in) then
  
              read(par_line(38:79),'(a42)') channel_line
              goto 20
            endif
          endif
 
        endif
      endif
 
      goto 10


  20  CONTINUE
 
      call sei close (close$,read01,code)
 
c
c  put components into array and find number
c

      do x=0,6

        if (channel_line(1+6*x:1+6*x).ne.' ') then
          
          comp_out(x+1)(1:5) = channel_line(1+6*x:6+6*x)          
          n_comp = n_comp+1


        endif
  
      enddo


        


      return
      end


      subroutine FREEFILE(filename)
c
c     get a unique file name
c
      implicit none
c
c     Purpose: get a unique filename
c
c     Input:  A trial filename
c     Output: A unique filename, starting with the trial filename
c
c     Urs Kradolfer, 16.7.90
c
      integer i, trimbeg,trimlen, i1,i2
      character*(*) filename
      character*100 testfilename, startfilename, string
      logical lexist
c
      i=0
ccc OSF1 does not like this!      if(filename.eq.' '.or.filename.eq.'')then
      if(filename.eq.' ')then
         startfilename='freefile'
      else
         startfilename=filename
      endif
      testfilename=startfilename
 1    inquire(file=testfilename,exist=lexist)
      if(.not.lexist)then
          filename=testfilename
          goto 888 ! RETURN
      else
         i=i+1
         write(string,'(i4.4)') i
         i1=trimbeg(string)
         i2=trimlen(string)
         testfilename=startfilename(1:trimlen(startfilename))//
     &                string(i1:i2)
         goto 1
      endif
c
 888  RETURN
c
      end ! of subr. freefile

